Edge
Date: 2019-10-22

org.jmol.util

## Class Edge

- java.lang.Object
- - org.jmol.util.Edge

- All Implemented Interfaces:
    SimpleEdge
  Direct Known Subclasses:
    Bond, SmilesBond

      public abstract class Edge
      extends java.lang.Object
      implements SimpleEdge

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Class and Description
    --- | ---
    `private static class` | `Edge.EnumBondOrder`

  - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `private static int[]` | `argbsHbondType`
    `private static int` | `ATROPISOMER_SHIFT`
    `static int` | `BOND_AROMATIC`
    `static int` | `BOND_AROMATIC_DOUBLE`
    `static int` | `BOND_AROMATIC_MASK`
    `static int` | `BOND_AROMATIC_SINGLE`
    `static int` | `BOND_COVALENT_DOUBLE`
    `static int` | `BOND_COVALENT_MASK`
    `static int` | `BOND_COVALENT_QUADRUPLE`
    `static int` | `BOND_COVALENT_QUINTUPLE`
    `static int` | `BOND_COVALENT_sextuple`
    `static int` | `BOND_COVALENT_SINGLE`
    `static int` | `BOND_COVALENT_TRIPLE`
    `static int` | `BOND_H_CALC`
    `static int` | `BOND_H_CALC_MASK`
    `static int` | `BOND_H_MINUS_3`
    `static int` | `BOND_H_MINUS_4`
    `static int` | `BOND_H_NUCLEOTIDE`
    `static int` | `BOND_H_PLUS_2`
    `static int` | `BOND_H_PLUS_3`
    `static int` | `BOND_H_PLUS_4`
    `static int` | `BOND_H_PLUS_5`
    `static int` | `BOND_H_REGULAR`
    `static int` | `BOND_HBOND_SHIFT`
    `static int` | `BOND_HYDROGEN_MASK`
    `static int` | `BOND_NEW`
    `static int` | `BOND_ORDER_ANY`
    `static int` | `BOND_ORDER_NULL`
    `static int` | `BOND_ORDER_UNSPECIFIED`
    `static int` | `BOND_PARTIAL_MASK`
    `static int` | `BOND_PARTIAL01`
    `static int` | `BOND_PARTIAL12`
    `static int` | `BOND_PARTIAL23`
    `static int` | `BOND_PARTIAL32`
    `static int` | `BOND_PYMOL_MULT`
    `static int` | `BOND_PYMOL_NOMULT`
    `static int` | `BOND_RENDER_SINGLE` Extended Bond Definition Types Originally these were short 16-bit values
    `static int` | `BOND_STEREO_FAR`
    `static int` | `BOND_STEREO_MASK`
    `static int` | `BOND_STEREO_NEAR`
    `static int` | `BOND_STRUT`
    `static int` | `BOND_SULFUR_MASK`
    `int` | `index`
    `int` | `order`
    `static int` | `TYPE_ATROPISOMER`
    `static int` | `TYPE_ATROPISOMER_REV`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `Edge()`

  - ### Method Summary

    All Methods Static Methods Instance Methods Abstract Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `static int` | `getArgbHbondType(int order)`
    `abstract int` | `getAtomIndex1()`
    `abstract int` | `getAtomIndex2()`
    `private static int` | `getAtropismCode(int order)`
    `static Node` | `getAtropismNode(int order, Node a1, boolean isFirst)`
    `static int` | `getAtropismOrder(int nn, int mm)`
    `static int` | `getAtropismOrder12(int nnmm)`
    `static int` | `getBondOrderFromFloat(float fOrder)`
    `static int` | `getBondOrderFromString(java.lang.String name)`
    `static java.lang.String` | `getBondOrderNameFromOrder(int order)`
    `static java.lang.String` | `getBondOrderNumberFromOrder(int order)` used for formatting labels and in the connect PARTIAL command
    `java.lang.String` | `getCIPChirality(boolean doCalculate)`
    `static java.lang.String` | `getCmlBondOrder(int order)`
    `protected static int` | `getCovalentBondOrder(int order)`
    `abstract int` | `getCovalentOrder()`
    `static int` | `getPartialBondDotted(int order)`
    `static int` | `getPartialBondOrder(int order)`
    `static boolean` | `isAtropism(int order)`
    `abstract boolean` | `isCovalent()`
    `abstract boolean` | `isHydrogen()`
    `static boolean` | `isOrderH(int order)`
    `void` | `setCIPChirality(int c)`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

    - ### Methods inherited from interface org.jmol.util.SimpleEdge

      `getOtherNode`

- - ### Field Detail

    - #### BOND_RENDER_SINGLE

          public static final int BOND_RENDER_SINGLE

      Extended Bond Definition Types Originally these were short 16-bit values
      See Also:
        Constant Field Values

    - #### TYPE_ATROPISOMER

          public static final int TYPE_ATROPISOMER

      See Also:
        Constant Field Values

    - #### TYPE_ATROPISOMER_REV

          public static final int TYPE_ATROPISOMER_REV

      See Also:
        Constant Field Values

    - #### ATROPISOMER_SHIFT

          private static final int ATROPISOMER_SHIFT

      See Also:
        Constant Field Values

    - #### BOND_STEREO_MASK

          public static final int BOND_STEREO_MASK

      See Also:
        Constant Field Values

    - #### BOND_STEREO_NEAR

          public static final int BOND_STEREO_NEAR

      See Also:
        Constant Field Values

    - #### BOND_STEREO_FAR

          public static final int BOND_STEREO_FAR

      See Also:
        Constant Field Values

    - #### BOND_AROMATIC_MASK

          public static final int BOND_AROMATIC_MASK

      See Also:
        Constant Field Values

    - #### BOND_AROMATIC_SINGLE

          public static final int BOND_AROMATIC_SINGLE

      See Also:
        Constant Field Values

    - #### BOND_AROMATIC_DOUBLE

          public static final int BOND_AROMATIC_DOUBLE

      See Also:
        Constant Field Values

    - #### BOND_AROMATIC

          public static final int BOND_AROMATIC

      See Also:
        Constant Field Values

    - #### BOND_SULFUR_MASK

          public static final int BOND_SULFUR_MASK

      See Also:
        Constant Field Values

    - #### BOND_PARTIAL_MASK

          public static final int BOND_PARTIAL_MASK

      See Also:
        Constant Field Values

    - #### BOND_PARTIAL01

          public static final int BOND_PARTIAL01

      See Also:
        Constant Field Values

    - #### BOND_PARTIAL12

          public static final int BOND_PARTIAL12

      See Also:
        Constant Field Values

    - #### BOND_PARTIAL23

          public static final int BOND_PARTIAL23

      See Also:
        Constant Field Values

    - #### BOND_PARTIAL32

          public static final int BOND_PARTIAL32

      See Also:
        Constant Field Values

    - #### BOND_COVALENT_MASK

          public static final int BOND_COVALENT_MASK

      See Also:
        Constant Field Values

    - #### BOND_COVALENT_SINGLE

          public static final int BOND_COVALENT_SINGLE

      See Also:
        Constant Field Values

    - #### BOND_COVALENT_DOUBLE

          public static final int BOND_COVALENT_DOUBLE

      See Also:
        Constant Field Values

    - #### BOND_COVALENT_TRIPLE

          public static final int BOND_COVALENT_TRIPLE

      See Also:
        Constant Field Values

    - #### BOND_COVALENT_QUADRUPLE

          public static final int BOND_COVALENT_QUADRUPLE

      See Also:
        Constant Field Values

    - #### BOND_COVALENT_QUINTUPLE

          public static final int BOND_COVALENT_QUINTUPLE

      See Also:
        Constant Field Values

    - #### BOND_COVALENT_sextuple

          public static final int BOND_COVALENT_sextuple

      See Also:
        Constant Field Values

    - #### BOND_ORDER_UNSPECIFIED

          public static final int BOND_ORDER_UNSPECIFIED

      See Also:
        Constant Field Values

    - #### BOND_ORDER_ANY

          public static final int BOND_ORDER_ANY

      See Also:
        Constant Field Values

    - #### BOND_ORDER_NULL

          public static final int BOND_ORDER_NULL

      See Also:
        Constant Field Values

    - #### BOND_STRUT

          public static final int BOND_STRUT

      See Also:
        Constant Field Values

    - #### BOND_PYMOL_NOMULT

          public static final int BOND_PYMOL_NOMULT

      See Also:
        Constant Field Values

    - #### BOND_PYMOL_MULT

          public static final int BOND_PYMOL_MULT

      See Also:
        Constant Field Values

    - #### BOND_NEW

          public static final int BOND_NEW

      See Also:
        Constant Field Values

    - #### BOND_HBOND_SHIFT

          public static final int BOND_HBOND_SHIFT

      See Also:
        Constant Field Values

    - #### BOND_HYDROGEN_MASK

          public static final int BOND_HYDROGEN_MASK

      See Also:
        Constant Field Values

    - #### BOND_H_REGULAR

          public static final int BOND_H_REGULAR

      See Also:
        Constant Field Values

    - #### BOND_H_CALC_MASK

          public static final int BOND_H_CALC_MASK

      See Also:
        Constant Field Values

    - #### BOND_H_CALC

          public static final int BOND_H_CALC

      See Also:
        Constant Field Values

    - #### BOND_H_PLUS_2

          public static final int BOND_H_PLUS_2

      See Also:
        Constant Field Values

    - #### BOND_H_PLUS_3

          public static final int BOND_H_PLUS_3

      See Also:
        Constant Field Values

    - #### BOND_H_PLUS_4

          public static final int BOND_H_PLUS_4

      See Also:
        Constant Field Values

    - #### BOND_H_PLUS_5

          public static final int BOND_H_PLUS_5

      See Also:
        Constant Field Values

    - #### BOND_H_MINUS_3

          public static final int BOND_H_MINUS_3

      See Also:
        Constant Field Values

    - #### BOND_H_MINUS_4

          public static final int BOND_H_MINUS_4

      See Also:
        Constant Field Values

    - #### BOND_H_NUCLEOTIDE

          public static final int BOND_H_NUCLEOTIDE

      See Also:
        Constant Field Values

    - #### argbsHbondType

          private static final int[] argbsHbondType

    - #### index

          public int index

    - #### order

          public int order

  - ### Constructor Detail

    - #### Edge

          public Edge()

  - ### Method Detail

    - #### getAtomIndex1

          public abstract int getAtomIndex1()

    - #### getAtomIndex2

          public abstract int getAtomIndex2()

    - #### getCovalentOrder

          public abstract int getCovalentOrder()

      Specified by:
        `getCovalentOrder` in interface `SimpleEdge`
      Returns:
        the bond order 1-4 if it is covalent, or 0 if not.

    - #### isCovalent

          public abstract boolean isCovalent()

      Specified by:
        `isCovalent` in interface `SimpleEdge`

    - #### isHydrogen

          public abstract boolean isHydrogen()

    - #### getArgbHbondType

          public static int getArgbHbondType(int order)

    - #### getBondOrderNumberFromOrder

          public static final java.lang.String getBondOrderNumberFromOrder(int order)

      used for formatting labels and in the connect PARTIAL command
      Parameters:
        `order` -
      Returns:
        a string representation to preserve float n.m

    - #### getCmlBondOrder

          public static final java.lang.String getCmlBondOrder(int order)

    - #### getBondOrderNameFromOrder

          public static final java.lang.String getBondOrderNameFromOrder(int order)

    - #### getAtropismOrder

          public static int getAtropismOrder(int nn,
                                             int mm)

    - #### getAtropismOrder12

          public static int getAtropismOrder12(int nnmm)

    - #### getAtropismCode

          private static int getAtropismCode(int order)

    - #### getAtropismNode

          public static Node getAtropismNode(int order,
                                             Node a1,
                                             boolean isFirst)

    - #### isAtropism

          public static boolean isAtropism(int order)

    - #### isOrderH

          public static boolean isOrderH(int order)

    - #### getPartialBondDotted

          public static final int getPartialBondDotted(int order)

    - #### getPartialBondOrder

          public static final int getPartialBondOrder(int order)

    - #### getCovalentBondOrder

          protected static final int getCovalentBondOrder(int order)

    - #### getBondOrderFromFloat

          public static final int getBondOrderFromFloat(float fOrder)

    - #### getBondOrderFromString

          public static int getBondOrderFromString(java.lang.String name)

    - #### setCIPChirality

          public void setCIPChirality(int c)

      Parameters:
        `c` -

    - #### getCIPChirality

          public java.lang.String getCIPChirality(boolean doCalculate)

      Parameters:
        `doCalculate` -
      Returns:
        CIP chirality label